package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.MajorCategory;
import com.zhongzheng.modules.user.bo.UserOcrAddBo;
import com.zhongzheng.modules.user.bo.UserOcrEditBo;
import com.zhongzheng.modules.user.bo.UserOcrQueryBo;
import com.zhongzheng.modules.user.domain.UserOcr;
import com.zhongzheng.modules.user.mapper.UserOcrMapper;
import com.zhongzheng.modules.user.service.IUserOcrService;
import com.zhongzheng.modules.user.vo.UserOcrVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户ocr信息Service业务层处理
 *
 * @author ruoyi
 * @date 2021-06-21
 */
@Service
public class UserOcrServiceImpl extends ServiceImpl<UserOcrMapper, UserOcr> implements IUserOcrService {

    @Override
    public UserOcrVo queryById(Long ocrId){
        UserOcr db = this.baseMapper.selectById(ocrId);
        return BeanUtil.toBean(db, UserOcrVo.class);
    }

    @Override
    public UserOcr queryByUserId(Long userId) {
        UserOcr info = getOne(new LambdaQueryWrapper<UserOcr>()
                .eq(UserOcr::getUserId,userId)
                .last("limit 1"));
        return info;
    }

    @Override
    public List<UserOcrVo> queryList(UserOcrQueryBo bo) {
        LambdaQueryWrapper<UserOcr> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getOcrFront()), UserOcr::getOcrFront, bo.getOcrFront());
        lqw.eq(StrUtil.isNotBlank(bo.getOcrBack()), UserOcr::getOcrBack, bo.getOcrBack());
        lqw.eq(StrUtil.isNotBlank(bo.getBestFrame()), UserOcr::getBestFrame, bo.getBestFrame());
        lqw.eq(StrUtil.isNotBlank(bo.getOcrInfo()), UserOcr::getOcrInfo, bo.getOcrInfo());
        lqw.eq(bo.getStatus() != null, UserOcr::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserOcrVo> entity2Vo(Collection<UserOcr> collection) {
        List<UserOcrVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserOcrVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserOcr> page = (Page<UserOcr>)collection;
            Page<UserOcrVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserOcrAddBo bo) {
        UserOcr add = BeanUtil.toBean(bo, UserOcr.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserOcrEditBo bo) {
        UserOcr update = BeanUtil.toBean(bo, UserOcr.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserOcr entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
